#!/usr/bin/perl
#this program converts civs modpacks to their freeciv counterparts
#Copyright (c) 2003, 2004 John Bauman

#Permission is hereby granted, free of charge, to any person obtaining a copy 
#of this software and associated documentation files (the "Software"), to deal 
#in the Software without restriction, including without limitation the rights 
#to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
#copies of the Software, and to permit persons to whom the Software is furnished 
#to do so, subject to the following conditions:

#The above copyright notice and this permission notice shall be included in all 
#copies or substantial portions of the Software.

#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
#INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
#PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
#HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
#OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
#SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


open (IFILE, "rules.txt") || die "There needs to be a rules.txt in the current directory.";

while (chomp ($x = <IFILE>) && !($x eq "\@COSMIC")) {}
$cosmnum = 0;
while (chomp ($x = <IFILE>) && !($x eq "") && !($x eq ";")) {
  ($cosm[$cosmnum], $comment) = split(/;/,$x);
  $cosm[$cosmnum] =~ s/ //g;
  $cosmnum++;
}



while (chomp ($x = <IFILE>) && !($x eq "\@CIVILIZE")) {}

$technum = 0;
while (chomp ($x = <IFILE>) && !($x eq "") && !($x eq ";")) {
  ($name[$technum], $blah1, $blah4, $req1[$technum], $req2[$technum], $blah2, $blah3) = split(/,/,$x);
  ($blah2, $n) = split(/\;/, $blah3);
  $req1[$technum] =~ s/ //g;
  $req2[$technum] =~ s/ //g;
  $n =~ / *([A-Za-z0-9]+) */;
  $m = $1;
  $short{$m} = $name[$technum];
  $sname[$technum] = $m;

  #Civ2 annoyingly special-cases these
  #are they based on the actual name?
  $flags[$technum] = ""; 
  $flags[$technum] = "Population_Pollution_Inc" if ($m eq "Aut");
  $flags[$technum] = "Bridge" if ($m eq "Bri");
  $flags[$technum] = "Fortress" if ($m eq "Cst");
  $flags[$technum] = "Population_Pollution_Inc" if ($m eq "Ind");
  $flags[$technum] = "Population_Pollution_Inc" if ($m eq "MP");
  $flags[$technum] = "Reduce_Trireme_Loss2" if ($m eq "Nav");
  $flags[$technum] = "Bonus_Tech" if ($m eq "Phi");
  $flags[$technum] = "Population_Pollution_Inc" if ($m eq "Pla");
  $flags[$technum] = "Airbase" if ($m eq "Rad");
  $flags[$technum] = "Railroad" if ($m eq "RR");
  $flags[$technum] = "Farmland" if ($m eq "Rfg");
  $flags[$technum] = "Reduce_Trireme_Loss1" if ($m eq "Sea");
  $technum++;
}
$short{'nil'} = "None";
$short{'no'} = "Never";

open FRET, ">","modset\\techs.ruleset";
print FRET "[datafile]\n";
print FRET "description=\"Civ2 modpack techs\"\n";
print FRET "options=\"1.9\"\n\n";

for ($i = 0;$i < $technum; $i++) {
  if ($req1[$i] eq "no" || $req2[$i] eq "no") {
    next;
  }
  $name2 = $name[$i];
  $name2 =~ tr/[A-Z] /[a-z]_/;
  print FRET "[advance_$name2]\n";
  print FRET "name     = _(\"$name[$i]\")\n";
  print FRET "req1     = \"$short{$req1[$i]}\"\n";
  print FRET "req2     = \"$short{$req2[$i]}\"\n";
  print FRET "flags    = \"$flags[$i]\"\n";
  print FRET "\n"; 
}
close FRET;




while (chomp ($x = <IFILE>) && !($x eq "\@GOVERNMENTS")) {}

$gnum = 0;
while (chomp ($x = <IFILE>) && !($x eq "") && !($x eq ";")) {
  ($gname[$gnum],$gmtitle[$gnum],$gftitle[$gnum]) = split(/,/, $x);
  $gmtitle[$gnum] =~ s/^ +//;
  $gftitle[$gnum] =~ s/^ +//;
  $gnum++;
}

open (GTM, "gtemp.txt") || die "There needs to be a gtemp.txt in the current directory.";
open GOUT, ">", "modset\\governments.ruleset";

$sgov = -1;
while (<GTM>) {
  chomp;
  $sgov++ if (/##newgov/);
  s/##newgov//;
  s/##gov(\d)##/$gname[$1]/g;
  s/##tech-([A-Za-z0-9]*)##/$short{$1}/g;
  s/##mname##/$gmtitle[$sgov]/g;
  s/##fname##/$gftitle[$sgov]/g;
  s/##cosm(\d*)##/$cosm[$1]/g;
  print GOUT "$_\n";
}
close GOUT;
close GTM;


seek IFILE, 0, 0;
while (chomp ($x = <IFILE>) && !($x eq "\@TERRAIN")) {}

for ($i = 0; $i < 11; $i++) {#load main terrains
  chomp ($x = <IFILE>);
  my @tp = split(/,/,$x);
  ($a, $b) = split(/;/,$tp[15]);
  $tp[15] = $b; 
  for ($j = 1; $j < 16; $j++) {
    $tp[$j] =~ s/ //g;
  }
  $tshort{$tp[15]} = $tp[0];
  $tp[2] *= 5;
  $tlist[$i] = \@tp;
}
for ($i = 11; $i < 33; $i++) {#load specials
  chomp ($x = <IFILE>);  
  my @tp = split(/,/,$x);
  for ($j = 1; $j < 6; $j++) {
    $tp[$j] =~ s/ //g;
  }
  $tlist[$i] = \@tp;
}
$tshort{"yes"} = "yes";
$tshort{"no"} = "no";

##this is great
sub swapt  {
  my $a = shift;
  my $b = shift;
  $tlist[33] = $tlist[$a];
  $tlist[$a] = $tlist[$b];
  $tlist[$b] = $tlist[33];
  $tlist[33] = $tlist[$a+11];
  $tlist[$a+11] = $tlist[$b+11];
  $tlist[$b+11] = $tlist[33];
  $tlist[33] = $tlist[$a+22];
  $tlist[$a+22] = $tlist[$b+22];
  $tlist[$b+22] = $tlist[33];
}
swapt(0,7);
swapt(1,7);
swapt(2,3);
swapt(5,9);
swapt(6,9);
swapt(7,10);
swapt(8,10);
swapt(9,10);

open (TT, "ttemp.txt") || die "There needs to be a ttemp.txt in the current directory.";
open TOUT, ">", "modset\\terrain.ruleset";
$x = "";
while (chomp($x = <TT>) && !($x eq "####")) {
  print TOUT "$x\n";
}

for ($i = 0; $i < 11; $i++) {
  $name3 = $tlist[$i][0];
  $name3 =~ tr /[A-Z] /[a-z]_/;
  $tlist[$i][6] = $tshort{$tlist[$i][6]};
  $tlist[$i][10] = $tshort{$tlist[$i][10]};
  $tlist[$i][14] = $tshort{$tlist[$i][14]};
  print TOUT <<OUTTERR;
[terrain_$name3]
name		= _("$tlist[$i][0]")
movement_cost		= $tlist[$i][1]
defense_bonus		= $tlist[$i][2]
food			= $tlist[$i][3]
shield			= $tlist[$i][4]
trade			= $tlist[$i][5]
special_1_name		= _("$tlist[$i+11][0]")
food_special_1		= $tlist[$i+11][3]
shield_special_1	= $tlist[$i+11][4]
trade_special_1		= $tlist[$i+11][5]
special_2_name		= _("$tlist[$i+22][0]")
food_special_2		= $tlist[$i+22][3]
shield_special_2	= $tlist[$i+22][4]
trade_special_2		= $tlist[$i+22][5]
irrigation_result	= "$tlist[$i][6]"
irrigation_food_incr	= $tlist[$i][7]
irrigation_time		= $tlist[$i][8]
mining_result		= "$tlist[$i][10]"
mining_shield_incr	= $tlist[$i][11]
mining_time		= $tlist[$i][12]
transform_result	= "$tlist[$i][14]"
OUTTERR
  $x = " ";
  while (!($x eq "") && chomp($x = <TT>)) {
    $x =~ s/##terr(\d*)##/$tlist[$1][0]/g;
    print TOUT "$x\n";
  }
}
close TOUT;
close TT;


seek IFILE, 0, 0;
while (chomp ($x = <IFILE>) && !($x eq "\@IMPROVE")) {}

$impnum = 0;
$ireal = 0; #used to keep track of deletions
while (chomp ($x = <IFILE>) && !($x eq "") && !($x eq ";")) {
  if ($ireal eq 0) {#freeciv has no "Nothing"
    $ireal++;
    next;
  }
  ($bname[$impnum], $cost[$impnum], $upkeep[$impnum], $breq[$impnum], $blank) = split(/,/,$x);
  $bname[$impnum] =~ s/\(//; $bname[$impnum] =~ s/\)//;
  $cost[$impnum] =~ s/ //g; $cost[$impnum] *= 10;
  $upkeep[$impnum] =~ s/ //g;
  $breq[$impnum] =~ s/ //g; $breq[$impnum] = $short{$breq[$impnum]};
  $exptech[$impnum] = "";
  $won[$impnum] = 0;
  $impnum++;
}

while (chomp ($x = <IFILE>) && !($x eq "\@ENDWONDER")) {}
$i = $impnum - 28;
while (chomp ($x = <IFILE>) && !($x eq "")) {
  $x =~ /(..+),/;
  $exptech[$i] = $short{$1};
  $won[$i] = 1;
  $i++;
}
sub swap($$) {
  my $a = shift;
  my $b = shift;
  return ($b, $a);
}
#civ2 doesn't include a lot of things in its definition, so I'm using a template
open(BT,"btemp.txt") || die "There needs to be a btemp.txt in the current directory.";;
open FBL,">","modset\\buildings.ruleset";
while (chomp ($x = <BT>) && !($x eq "##endmove") ) {#move around the locations
  ($sa, $sb) = split(/-/,$x);
  ($bname[$sa], $bname[$sb]) = swap($bname[$sa], $bname[$sb]);
  ($cost[$sa], $cost[$sb]) = swap($cost[$sa], $cost[$sb]);
  ($upkeep[$sa], $upkeep[$sb]) = swap($upkeep[$sa], $upkeep[$sb]);
  ($breq[$sa], $breq[$sb]) = swap($breq[$sa], $breq[$sb]);
  ($exptech[$sa], $exptech[$sb]) = swap($exptech[$sa], $exptech[$sb]);
  ($won[$sa], $won[$sb]) = swap($won[$sa], $won[$sb]);
}
$ci = -1;
while (<BT>) {
  chomp;
  $ci++ if (/##\[/);
  $ci-- if (/##\[building_barracks_i/);
  if (/barracks\]/) {
    $exptech[$ci] = $short{'Gun'};
  } elsif(/^\[building_barracks_ii\]/) {
    $breq[$ci] = $short{'Gun'};
    $exptech[$ci] = $short{'Mob'};
    $bname[$ci] .= " II";
  } elsif(/^\[building_barracks_iii\]/) {
    $breq[$ci] = $short{'Mob'};
    $exptech[$ci] = "None";
    $bname[$ci] .= "I";
  }
  if (/^##/) {
    next;
  }
  s/##name##/$bname[$ci]/;
  s/##tech##/$breq[$ci]/;
  $ob = ($exptech[$ci] eq "" ? "None" : $exptech[$ci]) if (/##obs##/);
  s/##obs##/$ob/;
  $iswon = ($won[$ci]) ? "GreatWonder" : "Improvement";
  s/##iswon##/$iswon/;
  s/##won##/$won[$ci]/;
  s/##build##/$cost[$ci]/;
  s/##upk##/$upkeep[$ci]/;
  s/##bul(\d*)##/$bname[$1]/g;
  s/##cosm(\d*)##/$cosm[$1]/g;
  s/##tech-([A-Za-z0-9]*)##/$short{$1}/g;
  s/##gov(\d)##/$gname[$1]/g;
  s/##terr(\d)##/$tlist[$1][0]/g;
  print FBL "$_\n";
}
close FBL;
close BT;

$bname[3] = substr($bname[3], 0, length($bname[3]) - 4);






while (chomp ($x = <IFILE>) && !($x eq "\@UNITS")) {}

$unum = 0;
while (chomp ($x = <IFILE>) && !($x eq "") && !($x eq ";")) {
  my @unitp = split(/,/, $x);
  ($unitp[13],$comments) = split(/;/,$unitp[13]);
  for ($i = 1; $i < 14; $i++) {
    $unitp[$i] =~ s/ //g;   
  }
  $unitp[3] =~ s/\.//;
  $unitp[5] =~ s/a//; 
  $unitp[6] =~ s/d//; 
  $unitp[7] =~ s/h//;
  $unitp[8] =~ s/f//;
  $unitp[1] = $short{$unitp[1]};
  $unitp[12] = $short{$unitp[12]};
  $unitp[2] =~ s/0/Land/;
  $unitp[2] =~ s/1/Air/;
  $unitp[2] =~ s/2/Sea/;
  $unitp[9] *= 10;
  $unitp[7] *= 10;
  $ulist[$unum] = \@unitp;
  $unum++;
}
#in freeciv, units are obsoleted by units, while in civ2 they are obsoleted by techs
for ($i = 0; $i < $unum; $i++) {
  $upreq = $ulist[$i][1];
  if ($ulist[$i][1] eq "None" || $ulist[$i][1] eq "Never") {
    $ulist[$i][1] = "None";
    next;
  }
  for ($j = 0; $j < $unum; $j++) {
    if ($ulist[$i][1] eq $ulist[$j][12]) {
      $ulist[$i][1] = $ulist[$j][0];
      last;
    }
  }
  if ($upreq eq $ulist[$i][1]) { #Oops
    print "No unit found to obsolete: $ulist[$i][0]\n";
    $ulist[$i][1] = "None";
  }
}
sub qbstr($$) { #use to check if a number is flagged
  return substr($_[0],$_[1],1);
}
open UNITSET ,">","modset\\units.ruleset";  
open (UTMP, "utemp.txt") || die "There needs to be a utemp.txt in the current directory.";;

print UNITSET <<OUTHEAD;

; Modifying this file:
; You should not modify this file except to make bugfixes or
; for other "maintenance".  If you want to make custom changes,
; you should create a new datadir subdirectory and copy this file
; into that directory, and then modify that copy.  Then use the
; command "rulesetdir <mysubdir>" in the server to have freeciv
; use your new customized file.

; See data/default/units.ruleset for more information.

[datafile]
description="Civ2 unit_type data for Freeciv (approximate)"
options="1.9"

[veteran_system]
; What are the names of the levels?
veteran_names = _("green"), _("veteran")

; The percentage chance of increasing level through combat
veteran_raise_chance = 50, 0

; Power factors are as a percentage.
; +50% is represented by 150
veteran_power_fact = 100, 150

; The percentage chance of a settler/engineer increasing level through
; performing useful work (per turn)
veteran_work_raise_chance = 0, 0

; The chances of a trireme being lost at sea when not adjacent to a
; land tile.
veteran_highseas_loss_pct = 50, 50

; The additional number of movement points granted for different veteran
; levels.  These are thirds of points, so to increase movement
; by a whole point 3 must be specified.
veteran_move_bonus = 0, 0

; Below: The individual units, one per section.
;
; The number can be variable, up to 200.  
; However for the "official" rulesets, units should not be removed 
; because that would break backward compatability with savegames.
;
; The order here matters: later units are considered "better" for
; a given flag or role.  
;
; The actual tag used (the * in [unit_*]) does not matter, except 
; it must be unique within this file, and it may be used in debug 
; output when reading this file.
;
; ** Fields **
;
; name          = name as seen by user 
; graphic       = tag specifing preferred graphic
; graphic_alt	= tag for alternate garphic if preferred graphic is not 
;		  present; especially if preferred graphic is non-standard, 
;		  this should be a standard tag.  Otherwise can use eg "-" 
;		  for no alternate graphic.
; tech_req      = required advance, names from techs.ruleset, or special:
;                 "None" => available from start
; obsolete_by   = can be upgraded to and made obsolete by another unit by name
; class         = "Land", "Sea", "Air", "Helicopter", "Missile" or "Nuclear"
; transport_cap = Number of units (ground, or air/missiles, depending on flags)
; fuel          = number of turns air units can fly before they crash. For
;                 barbarians this is used as lifetime instead
; uk_*          = upkeep costs, these are used as base values in the game
; flags         = special flag strings
; roles         = special role strings
; sound_move	= optional sound effect when the unit moves
; sound_move_alt= optional alternative sound effect if above not
;		  supported in client
; sound_fight	= optional sound effect when the unit fights
; sound_fight_alt= optional alternative sound effect if above not
;		   supported in client
; helptext	= optional help text string; should escape all raw newlines 
;		  so that xgettext parsing works
;
; Following flag strings require extra fields:
;  "Paratroopers"
;   paratroopers_range = the maximal range the unit can be paradropped to
;   paratroopers_mr_req = the move rate which is required at least for
;                         paradropping
;   paratroopers_mr_sub = the move rate which is subtracted after paradropping
;

OUTHEAD

for ($i = 0; $i < $unum; $i++) {
  $cunitx = $ulist[$i];
  @cunit = @$cunitx;
  $unames = $cunit[0];
  if ($cunit[12] eq "Never") {
    next;
  }
  $unames =~ tr/[A-Z] /[a-z]_/;
  $unames =~ s/\.//g;
  
  $cunit[10] = 8 if (qbstr($cunit[13], 11));
  $cunit[10] = 8 if (qbstr($cunit[13], 7));
  $cunit[2] = "Missile" if (qbstr($cunit[13], 2));
  $cunit[2] = "Nuclear" if ($cunit[5] eq 99);
  
  $popcost = ($cunit[11] eq 5) ? 1 : 0;
  $shield = ($cunit[11] eq 6 || $cunit[11] eq 7 ||(qbstr($cunit[13],5) && qbstr($cunit[13],13) && $cunit[5] eq 0)) ? 0 : 1;
  $vision = (substr($cunit[13],14,1)) ? 8 : 2;
  $happy = ($cunit[11] eq 5 || $cunit[11] eq 6 || $cunit[11] eq 7 ||
            ($cunit[2] eq "Air" && $cunit[4] eq 1) || (qbstr($cunit[13],5) && qbstr($cunit[13],13) && $cunit[5] eq 0)) ? 0 : 1;

  $uflags = "";
  $uflags .= " IgZOC" if (qbstr($cunit[13],13));
  $uflags .= " Marines" if (qbstr($cunit[13],12));
  $uflags .= " Partial_Invis Missile_Carrier No_Land_Attack" if (qbstr($cunit[13],11));
  $uflags .= " Fighter" if (qbstr($cunit[13],10));
  $uflags .= " Trireme" if (qbstr($cunit[13],9));
  $uflags .= " IgWall" if (qbstr($cunit[13],8));
  $uflags .= " Carrier" if (qbstr($cunit[13],7));
  $uflags .= " Paratroopers" if (qbstr($cunit[13],6));
  $uflags .= " IgTer" if (qbstr($cunit[13],5));
  $uflags .= " Pikemen" if (qbstr($cunit[13],4));
  $uflags .= " Fanatic" if (qbstr($cunit[13],3));
  $uflags .= " FieldUnit OneAttack Missile" if (qbstr($cunit[13],2));
  $uflags .= " AEGIS" if (qbstr($cunit[13],1));
  $uflags .= " NonMil" if ($cunit[5] eq 0);
  $uflags .= " NoVeteran" if ($cunit[5] eq 0);
  $uflags .= " TradeRoute HelpWonder" if ($cunit[11] eq 7);
  $uflags .= " Diplomat" if ($cunit[11] eq 6);
  $uflags .= " Spy" if ($cunit[11] eq 6 && $cunit[1] eq "None");
  $uflags .= " Settlers Airbase AddToCity Cities" if ($cunit[11] eq 5);
  $uflags .= " Transform" if ($cunit[11] eq 5 && $cunit[3] eq 2);
  $uflags .= " FieldUnit OneAttack" if ($cunit[2] eq "Air" && $cunit[4] eq 2);
  $uflags .= " Nuclear" if ($cunit[5] eq 99);
  $uflags .= " BadCityDefender" if ($cunit[2] eq "Sea");
  $uflags .= " Horse" if ($cunit[3] eq 2 && $cunit[5] < 10 && $cunit[5] > 0);#how does civ2 do it?
  $uflags =~ s/^ //;
  $uflags =~ s/ /", "/g;


  $uroles = ""; #these need to be fixed
  $uroles .= " Ferryboat" if ($cunit[10] > 0 && $cunit[2] eq "Sea");
  $uroles .= " Explorer" if (qbstr($cunit[13],5) && qbstr($cunit[13],13) && $cunit[5] eq 0);
  $uroles .= " Hut" if ($cunit[5] > $cunit[6] && $cunit[5] < 5);
  $uroles .= " FirstBuild" if ($cunit[5] eq 1);
  $uroles .= " Barbarian" if ($cunit[3] eq 2 && $cunit[5] <= 2 && $cunit[11] < 5);
  $uroles .= " BarbarianBuild BarbarianSea" if ($cunit[3] eq 1 && $cunit[5] <= 4 && $cunit[11] < 5);
  $uroles .= " BarbarianBoat" if ($cunit[2] eq "Sea" && !qbstr($cunit[13],9) && $cunit[10] <= 4 && $cunit[11] < 5);
  $uroles .= " Settlers Cities" if ($cunit[11] eq 5);
  $uroles .= " Diplomat" if ($cunit[11] eq 6);
  $uroles =~ s/^ //;
  $uroles =~ s/ /", "/g;
  

  print UNITSET <<OUTUNIT;
[unit_$unames]
name          = _("$cunit[0]")
class         = "$cunit[2]"
tech_req      = "$cunit[12]"
obsolete_by   = "$cunit[1]"
OUTUNIT
  $x = " ";
  while (chomp($x = <UTMP>) && !($x eq "")) {
    print UNITSET "$x\n";
  } 
  print UNITSET <<OUTUNIT;
build_cost    = $cunit[9]
pop_cost      = $popcost
attack        = $cunit[5]
defense       = $cunit[6]
hitpoints     = $cunit[7]
firepower     = $cunit[8]
move_rate     = $cunit[3]
vision_radius_sq = $vision
transport_cap = $cunit[10]
fuel          = $cunit[4]
uk_happy      = $happy
uk_shield     = $shield
uk_food       = $popcost
uk_gold       = 0
flags         = "$uflags"
roles         = "$uroles"
helptext      = ""
OUTUNIT

  if (qbstr($cunit[13],6)) {
    print UNITSET <<OUTUNIT;
paratroopers_range = $cosm[19]
paratroopers_mr_req = 1
paratroopers_mr_sub = 0
OUTUNIT
  }

  print UNITSET "\n";
}
print UNITSET <<OUTUNIT;
[unit_barbarian_leader]
name          = _("Barbarian Leader")
class         = "Land"
tech_req      = "None"
obsolete_by   = "None"
graphic       = "u.barbarian_leader"
graphic_alt   = "u.diplomat"
sound_move    = "m_barbarian_leader"
sound_move_alt = "m_generic"
sound_fight   = "f_barbarian_leader"
sound_fight_alt = "f_generic"
build_cost    = 40
pop_cost      = 0
attack        = 0
defense       = 0
hitpoints     = 10
firepower     = 1
move_rate     = 2
vision_radius_sq = 2
transport_cap = 0
fuel          = 0
uk_happy      = 0
uk_shield     = 0
uk_food       = 0
uk_gold       = 0
flags         = "IgZOC", "NonMil", "NoBuild"
roles         = "BarbarianLeader"
helptext      = _("\
When barbarian leader is killed on a tile without any defending units, \
the 100 gold ransom is paid, but only to land units and helicopters.\
")

[u_specials]
partisan_req = "$short{'Gun'}","$short{'Cmn'}"
OUTUNIT

close UNITSET;




open CITY, ">", "modset\\cities.ruleset";
print CITY <<OUTCITIES;
[datafile]
description="Cities data for Freeciv"
options="1.9"

; A specialist is a city citizen who is not a tile worker.  Usually the
; player can control what specialist each citizen is, so long as the
; requirements for that specialist are met.
;
; Below are the entries for the specialists, one per specialist type.
; The tag name (in [specialist_*]) doesn't matter so long as it's unique.
; For each specialist the following fields may be set:
;
; 
; name		= name as seen by user 
; short_name    = one-character "short name" used (for instance) in cityrep
; reqs		= requirements to have the specialist pick (see
;		  effects.ruleset and README.effects for help on requirements)

[specialist_elvis]
name		= _("elvis")
short_name	= _("?Elvis:E")
reqs		=
    { "type", "name", "range"
; Nothing
    }

[specialist_scientist]
name		= _("scientist")
short_name	= _("?Scientist:S")
reqs		=
    { "type", "name", "range"
      "MinSize", "5", "City"
    }

[specialist_taxman]
name		= _("taxman")
short_name	= _("?Taxman:T")
reqs		=
    { "type", "name", "range"
      "MinSize", "5", "City"
    }

[parameters]
add_to_size_limit  = 8		; cities >= this cannot be added to.
angry_citizens = 1              ; set to zero to disable angry citizens
celebrate_size_limit = 3        ; cities >= can celebrate

changable_tax = 1		; set to zero to disallow changing of tax rates

;forced_science = 0		; set these fields when changeable_tax is turned off
;forced_luxury = 100
;forced_gold = 0

;
; City styles define the way cities are drawn
;
; graphic     = group of tiles to use, see cities spec for
;               more info on city tiles
; citizens_graphic     = group of citizens tiles to use, see citizens/small
;                        spec for more info on citizens tiles
; reqs        = requirements for this city style (see README.effects)
; replaced_by = which style replaced this one

[citystyle_european]
name        = _("European")
graphic     = "city.european"
graphic_alt = "-"
citizens_graphic     = "ancient"
citizens_graphic_alt = "generic"
; No reqs
replaced_by = "Industrial"

[citystyle_classical]
name        = _("Classical")
graphic     = "city.classical"
graphic_alt = "-"
citizens_graphic     = "ancient"
citizens_graphic_alt = "generic"
; No reqs
replaced_by = "Industrial"

[citystyle_tropical]
name        = _("Tropical")
graphic     = "city.tropical"
graphic_alt = "city.european"
citizens_graphic     = "ancient"
citizens_graphic_alt = "generic"
; No reqs
replaced_by = "Industrial"

[citystyle_asian]
name        = _("Asian")
graphic     = "city.asian"
graphic_alt = "city.classical"
citizens_graphic     = "ancient"
citizens_graphic_alt = "generic"
; No reqs
replaced_by = "Industrial"

[citystyle_babylonian]
name        = _("Babylonian")
graphic     = "city.babylonian"
graphic_alt = "city.classical"
citizens_graphic     = "ancient"
citizens_graphic_alt = "generic"
; No reqs
replaced_by = "Industrial"

[citystyle_celtic]
name        = _("Celtic")
graphic     = "city.celtic"
graphic_alt = "city.european"
citizens_graphic     = "ancient"
citizens_graphic_alt = "generic"
; No reqs
replaced_by = "Industrial"

[citystyle_industrial]
name        = _("Industrial")
graphic     = "city.industrial"
graphic_alt = "-"
citizens_graphic     = "industrial"
citizens_graphic_alt = "generic"
reqs = { "type", "name", "range"
         "tech", "$short{'RR'}", "Player"
       }
replaced_by = "Modern"

[citystyle_modern]
name        = _("Modern")
graphic     = "city.modern"
graphic_alt = "-"
citizens_graphic     = "modern"
citizens_graphic_alt = "generic"
reqs = { "type", "name", "range"
         "tech", "$short{'Aut'}", "Player"
       }
replaced_by = "PostModern"

[citystyle_postmodern]
name        = _("PostModern")
graphic     = "city.postmodern"
graphic_alt = "-"
citizens_graphic     = "postmodern"
citizens_graphic_alt = "generic"
reqs = { "type", "name", "range"
         "tech", "$short{'Sup'}", "Player"
       }
replaced_by = "-"
OUTCITIES

close CITY;







open EOUT, ">", "modset\\effects.ruleset";
open(ETN, "etemp.txt");
while (<ETN>) {
  s/##bul(\d*)##/$bname[$1]/g;
  s/##cosm(\d*)##/$cosm[$1]/g;
  s/##tech-([A-Za-z0-9]*)##/$short{$1}/g;
  s/##tech(\d+)##/$name[$1]/g;
  s/##gov(\d)##/$gname[$1]/g;
  s/##terr(\d+)##/$tlist[$1][0]/g;
  print EOUT $_;;
}
close EOT;
close ETN;




@nationflags = qw(rome iraq_old germany egypt usa greece
india russia south_africa france mexico china england
mongolia wales japan norway spain iran tunisia cheyenne);
$nations = 1;
open (CTN, "city.txt") || ($nations = 0); ##don't bother with the rest then
if ($nations eq 0) {
  close IFILE;
  exit(0);
}
open NOUT, ">", "modset\\nations.ruleset";
print NOUT <<OUTNAT; 
[datafile]
description="Civmod nations data for Freeciv"
options="1.9"

OUTNAT

while (chomp ($x = <IFILE>) && !($x eq "\@LEADERS")) {}
$nations = 0;
while (chomp ($x = <IFILE>) && !($x eq "") && !($x eq ";")) {
  $x =~ s/, +/,/g;
  my @nationset = split(/,/,$x);
  $name2 = $nationset[6];
  $name2 =~ tr/[A-Z] /[a-z]_/;
  $nstyle = "Babylonian" if ($nationset[4] eq 0);
  $nstyle = "Classical" if ($nationset[4] eq 1);
  $nstyle = "Asian" if ($nationset[4] eq 2);
  $nstyle = "European" if ($nationset[4] eq 3);
  $nationset[7]++;
  $nationset[8]++;
  $nationset[9]++;
  print NOUT <<OUTNAT;  
[nation_$name2]

name=_("$nationset[6]")
plural=_("?plural:$nationset[5]")
legend=""
leader="$nationset[0]", "$nationset[1]"
leader_sex="Male", "Female"
flag="$nationflags[$nations]"
flag_alt="-"
city_style = "$nstyle"

init_techs=""
init_buildings=""
init_government="$gname[1]"
init_units=""

OUTNAT
  if (!($nationset[10] eq "")) {
    print NOUT 'ruler_titles = { "government",      "male_title",      "female_title"';
    print NOUT "\n";
    $i = 10;
    while (!($nationset[$i] eq "")) {
      print NOUT <<OUTNAT;
                 "$gname[$nationset[$i]]", _("$nationset[$i + 1]"), _("$nationset[$i + 2]")
OUTNAT
      $i += 3;
    }
    print NOUT "               }\n\n";
  }
  seek CTN, 0, 0;
  $name2 = $nationset[5];
  $name2 =~ tr/[a-z]/[A-Z]/; 
  print NOUT "cities = \n";
  while (chomp ($x = <CTN>) && !($x =~ /\@$name2/)) {}
  $i = 0;
  while (chomp ($x = <CTN>) && !($x eq "\@STOP")) {
    if ($i > 0) {
      print NOUT ",\n";
    } else {
      $i = 1;
    }
    print NOUT "  \"$x\"";
  }
  print NOUT '  "Nowhere"' if ($i eq 0);
  print NOUT "\n\n";

  $nations++;
}

#print NOUT "[misc]\n\n";
#print NOUT "cities = \n";
while (chomp ($x = <CTN>) && !($x =~ /\@EXTRA/)) {}
$i = 0;
while (chomp ($x = <CTN>) && !($x eq "\@STOP")) {
  if ($i > 0) {
   # print NOUT ",\n";
  } else {
    $i = 1;
  }
  #print NOUT "  \"$x\"";
}
#print NOUT "\n\n";




print NOUT <<OUTNAT; 
[nation_barbarian]

name=_("Barbarian")
plural=_("?plural:Barbarians")
legend="The murderous barbarians"
leader="Genseric", "Alaric", "Teodoric", "Herman"
leader_sex="Male", "Male", "Male", "Male"
flag="f.barbarian"
flag_alt = "-"
city_style = "European"

init_techs=""
init_buildings=""
init_government="$gname[1]"
init_units=""

cities = 
OUTNAT

while (chomp ($x = <CTN>) && !($x =~ /\@BARBARIANS/)) {}
$x = <CTN>; # what does this number mean?
$i = 0;
while (chomp ($x = <CTN>) && !($x eq "\@STOP") && !($x eq "")) {
  if ($i > 0) {
    print NOUT ",\n";
  } else {
    $i = 1;
  }
  print NOUT "  \"$x\"";
}
print NOUT "\n\n";




close NOUT;
close CTN;


close IFILE;
 